Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.velocity.runtime
Class RuntimeSingleton

    java.lang.Object
      |
      +--org.apache.velocity.runtime.RuntimeSingleton

All Implemented Interfaces:
  RuntimeConstants

public class RuntimeSingleton
extends java.lang.Object
implements RuntimeConstants

This is the Runtime system for Velocity. It is the single access point for all functionality in Velocity. It adheres to the mediator pattern and is the only structure that developers need to be familiar with in order to get Velocity to perform. The Runtime will also cooperate with external systems like Turbine. Runtime properties can set and then the Runtime is initialized. Turbine for example knows where the templates are to be loaded from, and where the velocity log file should be placed. So in the case of Velocity cooperating with Turbine the code might look something like the following:

     Runtime.setProperty(Runtime.FILE_RESOURCE_LOADER_PATH, templatePath);
     Runtime.setProperty(Runtime.RUNTIME_LOG, pathToVelocityLog);
     Runtime.init();

     -----------------------------------------------------------------------
     N O T E S  O N  R U N T I M E  I N I T I A L I Z A T I O N
     -----------------------------------------------------------------------
     Runtime.init()

     If Runtime.init() is called by itself the Runtime will
     initialize with a set of default values.
     -----------------------------------------------------------------------
     Runtime.init(String/Properties)

     In this case the default velocity properties are layed down
     first to provide a solid base, then any properties provided
     in the given properties object will override the corresponding
     default property.
     -----------------------------------------------------------------------

Version:
  $Id: RuntimeSingleton.java,v 1.4 2001/10/31 02:59:28 geirm Exp $
Author:
  Jason van Zyl, Jeff Bowden, Geir Magusson Jr.

Field Summary
`private static RuntimeInstance` | `ri`

Fields inherited from interface org.apache.velocity.runtime.RuntimeConstants
`COUNTER_INITIAL_VALUE, COUNTER_NAME, DEBUG_PREFIX, DEFAULT_RUNTIME_DIRECTIVES, DEFAULT_RUNTIME_PROPERTIES, ENCODING_DEFAULT, ERROR_PREFIX, ERRORMSG_END, ERRORMSG_START, FILE_RESOURCE_LOADER_CACHE, FILE_RESOURCE_LOADER_PATH, INFO_PREFIX, INPUT_ENCODING, INTERPOLATE_STRINGLITERALS, LOGSYSTEM_LOG4J_EMAIL_BUFFER_SIZE, LOGSYSTEM_LOG4J_EMAIL_FROM, LOGSYSTEM_LOG4J_EMAIL_SERVER, LOGSYSTEM_LOG4J_EMAIL_SUBJECT, LOGSYSTEM_LOG4J_EMAIL_TO, LOGSYSTEM_LOG4J_FILE_BACKUPS, LOGSYSTEM_LOG4J_FILE_SIZE, LOGSYSTEM_LOG4J_PATTERN, LOGSYSTEM_LOG4J_REMOTE_HOST, LOGSYSTEM_LOG4J_REMOTE_PORT, LOGSYSTEM_LOG4J_SYSLOGD_FACILITY, LOGSYSTEM_LOG4J_SYSLOGD_HOST, NUMBER_OF_PARSERS, OUTPUT_ENCODING, PARSE_DIRECTIVE_MAXDEPTH, PARSER_POOL_SIZE, RESOURCE_LOADER, RESOURCE_MANAGER_CACHE_CLASS, RESOURCE_MANAGER_CLASS, RESOURCE_MANAGER_LOGWHENFOUND, RUNTIME_LOG, RUNTIME_LOG_ERROR_STACKTRACE, RUNTIME_LOG_INFO_STACKTRACE, RUNTIME_LOG_LOGSYSTEM, RUNTIME_LOG_LOGSYSTEM_CLASS, RUNTIME_LOG_REFERENCE_LOG_INVALID, RUNTIME_LOG_WARN_STACKTRACE, UNKNOWN_PREFIX, VM_CONTEXT_LOCALSCOPE, VM_LIBRARY, VM_LIBRARY_AUTORELOAD, VM_MESSAGES_ON, VM_PERM_ALLOW_INLINE, VM_PERM_ALLOW_INLINE_REPLACE_GLOBAL, VM_PERM_INLINE_LOCAL, WARN_PREFIX`

Constructor Summary
`RuntimeSingleton()`

Method Summary
`static void` | `addProperty(java.lang.String key, java.lang.Object value)` Add a property to the configuration.
`static boolean` | `addVelocimacro(java.lang.String name, java.lang.String macro, java.lang.String[] argArray, java.lang.String sourceTemplate)` Adds a new Velocimacro.
`static void` | `clearProperty(java.lang.String key)` Clear the values pertaining to a particular property.
`private static Parser` | `createNewParser()` Returns a JavaCC generated Parser.
`static void` | `debug(java.lang.Object message)` Log a debug message.
`static boolean` | `dumpVMNamespace(java.lang.String namespace)` tells the vmFactory to dump the specified namespace.
`static void` | `error(java.lang.Object message)` Log an error message.
`static boolean` | `getBoolean(java.lang.String key, boolean def)` Boolean property accessor method to hide the configuration implementation.
`static org.apache.commons.collections.ExtendedProperties` | `getConfiguration()` Return the velocity runtime configuration object.
`static ContentResource` | `getContent(java.lang.String name)` Returns a static content resource from the resource manager.
`static ContentResource` | `getContent(java.lang.String name, java.lang.String encoding)` Returns a static content resource from the resource manager.
`static int` | `getInt(java.lang.String key)` Int property accessor method to hide the configuration implementation.
`static int` | `getInt(java.lang.String key, int defaultValue)` Int property accessor method to hide the configuration implementation.
`static Introspector` | `getIntrospector()` Return the Introspector for this RuntimeInstance
`static java.lang.String` | `getLoaderNameForResource(java.lang.String resourceName)` Determines is a template exists, and returns name of the loader that provides it.
`static java.lang.Object` | `getProperty(java.lang.String key)` Allows an external caller to get a property.
`static RuntimeInstance` | `getRuntimeInstance()` returns the RuntimeInstance object for this singleton For internal use only :)
`static RuntimeServices` | `getRuntimeServices()`
`static java.lang.String` | `getString(java.lang.String key)` String property accessor method to hide the configuration implementation
`static java.lang.String` | `getString(java.lang.String key, java.lang.String defaultValue)` String property accessor method with default to hide the configuration implementation.
`static Template` | `getTemplate(java.lang.String name)` Returns a `Template` from the resource manager.
`static Template` | `getTemplate(java.lang.String name, java.lang.String encoding)` Returns a `Template` from the resource manager
`static Directive` | `getVelocimacro(java.lang.String vmName, java.lang.String templateName)` Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.
`static void` | `info(java.lang.Object message)` Log an info message.
`static void` | `init()`
`static void` | `init(java.util.Properties p)` Initialize the Velocity Runtime with a Properties object.
`static void` | `init(java.lang.String configurationFile)` Initialize the Velocity Runtime with the name of ExtendedProperties object.
`static boolean` | `isVelocimacro(java.lang.String vmName, java.lang.String templateName)` Checks to see if a VM exists
`static SimpleNode` | `parse(java.io.Reader reader, java.lang.String templateName)` Parse the input and return the root of AST node structure.
`static SimpleNode` | `parse(java.io.Reader reader, java.lang.String templateName, boolean dumpNamespace)` Parse the input and return the root of the AST node structure.
`static void` | `setConfiguration(org.apache.commons.collections.ExtendedProperties configuration)` Allow an external system to set an ExtendedProperties object to use.
`static void` | `setProperty(java.lang.String key, java.lang.Object value)` Allows an external system to set a property in the Velocity Runtime.
`static void` | `warn(java.lang.Object message)` Log a warning message.

Methods inherited from class java.lang.Object
`, clone, equals, finalize, getClass, hashCode, notify, notifyAll, registerNatives, toString, wait, wait, wait`

Field Detail

### ri

    private static RuntimeInstance ri

Constructor Detail

### RuntimeSingleton

    public RuntimeSingleton()

Method Detail

### init

    public static void init()
                     throws java.lang.Exception

### getRuntimeServices

    public static RuntimeServices getRuntimeServices()

### setProperty

    public static void setProperty(java.lang.String key,
                                   java.lang.Object value)

  Allows an external system to set a property in the Velocity Runtime.
  Parameters:
    `String` - property key
    `String` - property value

### setConfiguration

    public static void setConfiguration(org.apache.commons.collections.ExtendedProperties configuration)

  Allow an external system to set an ExtendedProperties object to use. This is useful where the external system also uses the ExtendedProperties class and the velocity configuration is a subset of parent application's configuration. This is the case with Turbine.
  Parameters:
    `ExtendedProperties` - configuration

### addProperty

    public static void addProperty(java.lang.String key,
                                   java.lang.Object value)

  Add a property to the configuration. If it already exists then the value stated here will be added to the configuration entry. For example, if resource.loader = file is already present in the configuration and you addProperty("resource.loader", "classpath") Then you will end up with a Vector like the following: ["file", "classpath"]
  Parameters:
    `String` - key
    `String` - value

### clearProperty

    public static void clearProperty(java.lang.String key)

  Clear the values pertaining to a particular property.
  Parameters:
    `String` - key of property to clear

### getProperty

    public static java.lang.Object getProperty(java.lang.String key)

  Allows an external caller to get a property. The calling routine is required to know the type, as this routine will return an Object, as that is what properties can be.
  Parameters:
    `key` - property to return

### init

    public static void init(java.util.Properties p)
                     throws java.lang.Exception

  Initialize the Velocity Runtime with a Properties object.
  Parameters:
    `Properties` -

### init

    public static void init(java.lang.String configurationFile)
                     throws java.lang.Exception

  Initialize the Velocity Runtime with the name of ExtendedProperties object.
  Parameters:
    `Properties` -

### createNewParser

    private static Parser createNewParser()

  Returns a JavaCC generated Parser.
  Returns:
    Parser javacc generated parser

### parse

    public static SimpleNode parse(java.io.Reader reader,
                                   java.lang.String templateName)
                            throws ParseException

  Parse the input and return the root of AST node structure.
  In the event that it runs out of parsers in the pool, it will create and let them be GC'd dynamically, logging that it has to do that. This is considered an exceptional condition. It is expected that the user will set the PARSER_POOL_SIZE property appropriately for their application. We will revisit this.
  Parameters:
    `InputStream` - inputstream retrieved by a resource loader
    `String` - name of the template being parsed

### parse

    public static SimpleNode parse(java.io.Reader reader,
                                   java.lang.String templateName,
                                   boolean dumpNamespace)
                            throws ParseException

  Parse the input and return the root of the AST node structure.
  Parameters:
    `InputStream` - inputstream retrieved by a resource loader
    `String` - name of the template being parsed
    `dumpNamespace` - flag to dump the Velocimacro namespace for this template

### getTemplate

    public static Template getTemplate(java.lang.String name)
                                throws ResourceNotFoundException,
                                       ParseErrorException,
                                       java.lang.Exception

  Returns a `Template` from the resource manager. This method assumes that the character encoding of the template is set by the `input.encoding` property. The default is "ISO-8859-1"
  Parameters:
    `name` - The file name of the desired template.
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.
    `java.lang.Exception` - if an error occurs in template initialization

### getTemplate

    public static Template getTemplate(java.lang.String name,
                                       java.lang.String encoding)
                                throws ResourceNotFoundException,
                                       ParseErrorException,
                                       java.lang.Exception

  Returns a `Template` from the resource manager
  Parameters:
    `name` - The name of the desired template.
    `encoding` - Character encoding of the template
  Returns:
    The template.
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.
    `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.
    `java.lang.Exception` - if an error occurs in template initialization

### getContent

    public static ContentResource getContent(java.lang.String name)
                                      throws ResourceNotFoundException,
                                             ParseErrorException,
                                             java.lang.Exception

  Returns a static content resource from the resource manager. Uses the current value if INPUT_ENCODING as the character encoding.
  Parameters:
    `name` - Name of content resource to get
  Returns:
    parsed ContentResource object ready for use
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.

### getContent

    public static ContentResource getContent(java.lang.String name,
                                             java.lang.String encoding)
                                      throws ResourceNotFoundException,
                                             ParseErrorException,
                                             java.lang.Exception

  Returns a static content resource from the resource manager.
  Parameters:
    `name` - Name of content resource to get
    `encoding` - Character encoding to use
  Returns:
    parsed ContentResource object ready for use
  Throws:
    `ResourceNotFoundException` - if template not found from any available source.

### getLoaderNameForResource

    public static java.lang.String getLoaderNameForResource(java.lang.String resourceName)

  Determines is a template exists, and returns name of the loader that provides it. This is a slightly less hokey way to support the Velocity.templateExists() utility method, which was broken when per-template encoding was introduced. We can revisit this.
  Parameters:
    `resourceName` - Name of template or content resource
  Returns:
    class name of loader than can provide it

### warn

    public static void warn(java.lang.Object message)

  Log a warning message.
  Parameters:
    `Object` - message to log

### info

    public static void info(java.lang.Object message)

  Log an info message.
  Parameters:
    `Object` - message to log

### error

    public static void error(java.lang.Object message)

  Log an error message.
  Parameters:
    `Object` - message to log

### debug

    public static void debug(java.lang.Object message)

  Log a debug message.
  Parameters:
    `Object` - message to log

### getString

    public static java.lang.String getString(java.lang.String key,
                                             java.lang.String defaultValue)

  String property accessor method with default to hide the configuration implementation.
  Parameters:
    `String` - key property key
    `String` - defaultValue default value to return if key not found in resource manager.
  Returns:
    String value of key or default

### getVelocimacro

    public static Directive getVelocimacro(java.lang.String vmName,
                                           java.lang.String templateName)

  Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.
  Parameters:
    `String` - vmName Name of velocimacro requested
  Returns:
    String VelocimacroProxy

### addVelocimacro

    public static boolean addVelocimacro(java.lang.String name,
                                         java.lang.String macro,
                                         java.lang.String[] argArray,
                                         java.lang.String sourceTemplate)

  Adds a new Velocimacro. Usually called by Macro only while parsing.
  Parameters:
    `String` - name Name of velocimacro
    `String` - macro String form of macro body
    `String` - argArray Array of strings, containing the #macro() arguments. the 0th is the name.
  Returns:
    boolean True if added, false if rejected for some reason (either parameters or permission settings)

### isVelocimacro

    public static boolean isVelocimacro(java.lang.String vmName,
                                        java.lang.String templateName)

  Checks to see if a VM exists
  Parameters:
    `name` - Name of velocimacro
  Returns:
    boolean True if VM by that name exists, false if not

### dumpVMNamespace

    public static boolean dumpVMNamespace(java.lang.String namespace)

  tells the vmFactory to dump the specified namespace. This is to support clearing the VM list when in inline-VM-local-scope mode

### getString

    public static java.lang.String getString(java.lang.String key)

  String property accessor method to hide the configuration implementation
  Parameters:
    `key` - property key
  Returns:
    value of key or null

### getInt

    public static int getInt(java.lang.String key)

  Int property accessor method to hide the configuration implementation.
  Parameters:
    `String` - key property key
  Returns:
    int value

### getInt

    public static int getInt(java.lang.String key,
                             int defaultValue)

  Int property accessor method to hide the configuration implementation.
  Parameters:
    `key` - property key
    `int` - default value
  Returns:
    int value

### getBoolean

    public static boolean getBoolean(java.lang.String key,
                                     boolean def)

  Boolean property accessor method to hide the configuration implementation.
  Parameters:
    `String` - key property key
    `boolean` - default default value if property not found
  Returns:
    boolean value of key or default value

### getConfiguration

    public static org.apache.commons.collections.ExtendedProperties getConfiguration()

  Return the velocity runtime configuration object.
  Returns:
    ExtendedProperties configuration object which houses the velocity runtime properties.

### getIntrospector

    public static Introspector getIntrospector()

  Return the Introspector for this RuntimeInstance
  Returns:
    Introspector object for this runtime instance

### getRuntimeInstance

    public static RuntimeInstance getRuntimeInstance()

  returns the RuntimeInstance object for this singleton For internal use only :)
  Returns:
    RuntimeInstance the RuntimeInstance used by this Singleton instance

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003 Apache Software Foundation. All Rights Reserved.